package com.inca.npbusi.allotqtydef;

import com.inca.np.auth.ClientUserManager;
import com.inca.np.auth.Userruninfo;
import com.inca.np.demo.communicate.RemotesqlHelper;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.mde.CMasterModel;
import com.inca.np.gui.mde.CMdeModel;

public class Allotqty_def_master extends CMasterModel {
   public Allotqty_def_master(CFrame var1, CMdeModel var2) {
      super(var1, "销售配额定义总单", var2);
   }

   public String getTablename() {
      return "bms_sa_allotqty_def_doc_v";
   }

   public String getSaveCommandString() {
      return null;
   }

   protected int on_new(int var1) {
      Userruninfo var2 = ClientUserManager.getCurrentUser();
      this.setItemValue(var1, "inputman", var2.getUsername());
      this.setItemValue(var1, "inputmanid", var2.getUserid());
      return super.on_new(var1);
   }

   protected int on_beforedel(int var1) {
      String var2 = this.getItemValue(var1, "usestatus");
      return "1".equals(var2) ? -1 : super.on_beforedel(var1);
   }

   protected String getEditablecolumns(int var1) {
      String var2 = this.mdemodel.getMasterModel().getItemValue(var1, "usestatus");
      return "0".equals(var2) ? "opcode,startdate,enddate" : "nothing";
   }

   public int on_beforesave() {
      String var1 = null;
      String var2 = null;
      String var3 = null;
      String var4 = null;
      DBTableModel var5 = this.getModifiedDbmodel();
      DBTableModel var6 = null;
      var3 = null;
      var4 = null;
      var3 = null;
      RemotesqlHelper var7 = new RemotesqlHelper();

      for(int var8 = 0; var8 < var5.getRowCount(); ++var8) {
         if (var5.getdbStatus(var8) != 3) {
            var1 = var5.getItemValue(var8, "startdate");
            var2 = var5.getItemValue(var8, "enddate");
            if (var1.compareTo(var2) > 0) {
               this.infoMessage("提示", "\"开始生效时间\"不得比\"失效时间\"晚！");
               return -1;
            }

            var4 = var5.getItemValue(var8, "defdocid");
            var3 = var5.getItemValue(var8, "goodsid");
            var3 = "select startdate,enddate from bms_sa_allotqty_def_doc where usestatus<>2 and goodsid=" + var3;
            if (var4 != null && var4.length() > 0) {
               var3 = var3 + " and defdocid<>" + var4;
            }

            try {
               var6 = var7.doSelect(var3, 0, 99999);

               for(int var9 = 0; var9 < var6.getRowCount(); ++var9) {
                  var3 = var6.getItemValue(var9, "startdate");
                  var4 = var6.getItemValue(var9, "enddate");
                  if (var1.compareTo(var3) >= 0 && var1.compareTo(var4) <= 0 || var1.compareTo(var3) <= 0 && var2.compareTo(var3) >= 0) {
                     this.infoMessage("提示", "同一货品的配额定义出现时间段跨越！");
                     return -1;
                  }
               }
            } catch (Exception var10) {
               var10.printStackTrace();
            }
         }
      }

      return super.on_beforesave();
   }
}
